diff --git a/plugins/sudoers/gram.c b/plugins/sudoers/gram.c
index 0bb7285..3005216 100644
--- a/plugins/sudoers/gram.c
+++ b/plugins/sudoers/gram.c
@@ -2380,135 +2452,141 @@ yyreduce:
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_add(LEAK_RUNAS, (yyval.runas));
 			}
-#line 2379 "gram.c"
+#line 2452 "gram.c"
     break;
 
   case 71: /* reserved_word: ALL  */
-#line 706 "gram.y"
+#line 767 "gram.y"
                                         { (yyval.string) = "ALL"; }
-#line 2385 "gram.c"
+#line 2458 "gram.c"
     break;
 
   case 72: /* reserved_word: CHROOT  */
-#line 707 "gram.y"
+#line 768 "gram.y"
                                         { (yyval.string) = "CHROOT"; }
-#line 2391 "gram.c"
+#line 2464 "gram.c"
     break;
 
   case 73: /* reserved_word: CWD  */
-#line 708 "gram.y"
+#line 769 "gram.y"
                                         { (yyval.string) = "CWD"; }
-#line 2397 "gram.c"
+#line 2470 "gram.c"
     break;
 
   case 74: /* reserved_word: CMND_TIMEOUT  */
-#line 709 "gram.y"
+#line 770 "gram.y"
                                         { (yyval.string) = "CMND_TIMEOUT"; }
-#line 2403 "gram.c"
+#line 2476 "gram.c"
     break;
 
   case 75: /* reserved_word: NOTBEFORE  */
-#line 710 "gram.y"
+#line 771 "gram.y"
                                         { (yyval.string) = "NOTBEFORE"; }
-#line 2409 "gram.c"
+#line 2482 "gram.c"
     break;
 
   case 76: /* reserved_word: NOTAFTER  */
-#line 711 "gram.y"
+#line 772 "gram.y"
                                         { (yyval.string) = "NOTAFTER"; }
-#line 2415 "gram.c"
+#line 2488 "gram.c"
     break;
 
   case 77: /* reserved_word: ROLE  */
-#line 712 "gram.y"
+#line 773 "gram.y"
                                         { (yyval.string) = "ROLE"; }
-#line 2421 "gram.c"
+#line 2494 "gram.c"
     break;
 
   case 78: /* reserved_word: TYPE  */
-#line 713 "gram.y"
+#line 774 "gram.y"
                                         { (yyval.string) = "TYPE"; }
-#line 2427 "gram.c"
+#line 2500 "gram.c"
     break;
 
   case 79: /* reserved_word: PRIVS  */
-#line 714 "gram.y"
+#line 775 "gram.y"
                                         { (yyval.string) = "PRIVS"; }
-#line 2433 "gram.c"
+#line 2506 "gram.c"
     break;
 
   case 80: /* reserved_word: LIMITPRIVS  */
-#line 715 "gram.y"
+#line 776 "gram.y"
                                         { (yyval.string) = "LIMITPRIVS"; }
-#line 2439 "gram.c"
+#line 2512 "gram.c"
     break;
 
   case 81: /* reserved_alias: reserved_word  */
-#line 718 "gram.y"
+#line 779 "gram.y"
                                       {
 			    sudoerserrorf(U_("syntax error, reserved word %s used as an alias name"), (yyvsp[0].string));
 			    YYERROR;
 			}
-#line 2448 "gram.c"
+#line 2521 "gram.c"
     break;
 
   case 82: /* options: %empty  */
-#line 724 "gram.y"
+#line 785 "gram.y"
                                     {
 			    init_options(&(yyval.options));
 			}
-#line 2456 "gram.c"
+#line 2529 "gram.c"
     break;
 
   case 83: /* options: options chdirspec  */
-#line 727 "gram.y"
+#line 788 "gram.y"
                                           {
 			    free((yyval.options).runcwd);
 			    (yyval.options).runcwd = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 			}
-#line 2465 "gram.c"
+#line 2539 "gram.c"
     break;
 
   case 84: /* options: options chrootspec  */
-#line 731 "gram.y"
+#line 793 "gram.y"
                                            {
 			    free((yyval.options).runchroot);
 			    (yyval.options).runchroot = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 			}
-#line 2474 "gram.c"
+#line 2549 "gram.c"
     break;
 
   case 85: /* options: options notbeforespec  */
-#line 735 "gram.y"
+#line 798 "gram.y"
                                               {
 			    (yyval.options).notbefore = parse_gentime((yyvsp[0].string));
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 			    free((yyvsp[0].string));
 			    if ((yyval.options).notbefore == -1) {
 				sudoerserror(N_("invalid notbefore value"));
 				YYERROR;
 			    }
 			}
-#line 2487 "gram.c"
+#line 2563 "gram.c"
     break;
 
   case 86: /* options: options notafterspec  */
-#line 743 "gram.y"
+#line 807 "gram.y"
                                              {
 			    (yyval.options).notafter = parse_gentime((yyvsp[0].string));
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 			    free((yyvsp[0].string));
 			    if ((yyval.options).notafter == -1) {
 				sudoerserror(N_("invalid notafter value"));
 				YYERROR;
 			    }
 			}
-#line 2500 "gram.c"
+#line 2577 "gram.c"
     break;
 
   case 87: /* options: options timeoutspec  */
-#line 751 "gram.y"
+#line 816 "gram.y"
                                             {
 			    (yyval.options).timeout = parse_timeout((yyvsp[0].string));
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 			    free((yyvsp[0].string));
 			    if ((yyval.options).timeout == -1) {
 				if (errno == ERANGE)
@@ -2518,199 +2596,206 @@ yyreduce:
 				YYERROR;
 			    }
 			}
-#line 2516 "gram.c"
+#line 2594 "gram.c"
     break;
 
   case 88: /* options: options rolespec  */
-#line 762 "gram.y"
+#line 828 "gram.y"
                                          {
 #ifdef HAVE_SELINUX
 			    free((yyval.options).role);
 			    (yyval.options).role = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 #endif
 			}
-#line 2527 "gram.c"
+#line 2606 "gram.c"
     break;
 
   case 89: /* options: options typespec  */
-#line 768 "gram.y"
+#line 835 "gram.y"
                                          {
 #ifdef HAVE_SELINUX
 			    free((yyval.options).type);
 			    (yyval.options).type = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 #endif
 			}
-#line 2538 "gram.c"
+#line 2618 "gram.c"
     break;
 
   case 90: /* options: options privsspec  */
-#line 774 "gram.y"
+#line 842 "gram.y"
                                           {
 #ifdef HAVE_PRIV_SET
 			    free((yyval.options).privs);
 			    (yyval.options).privs = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 #endif
 			}
-#line 2549 "gram.c"
+#line 2630 "gram.c"
     break;
 
   case 91: /* options: options limitprivsspec  */
-#line 780 "gram.y"
+#line 849 "gram.y"
                                                {
 #ifdef HAVE_PRIV_SET
 			    free((yyval.options).limitprivs);
 			    (yyval.options).limitprivs = (yyvsp[0].string);
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
 #endif
 			}
-#line 2560 "gram.c"
+#line 2642 "gram.c"
     break;
 
   case 92: /* cmndtag: %empty  */
-#line 788 "gram.y"
+#line 858 "gram.y"
                                     {
 			    TAGS_INIT(&(yyval.tag));
 			}
-#line 2568 "gram.c"
+#line 2650 "gram.c"
     break;
 
   case 93: /* cmndtag: cmndtag NOPASSWD  */
-#line 791 "gram.y"
+#line 861 "gram.y"
                                          {
 			    (yyval.tag).nopasswd = true;
 			}
-#line 2576 "gram.c"
+#line 2658 "gram.c"
     break;
 
   case 94: /* cmndtag: cmndtag PASSWD  */
-#line 794 "gram.y"
+#line 864 "gram.y"
                                        {
 			    (yyval.tag).nopasswd = false;
 			}
-#line 2584 "gram.c"
+#line 2666 "gram.c"
     break;
 
   case 95: /* cmndtag: cmndtag NOEXEC  */
-#line 797 "gram.y"
+#line 867 "gram.y"
                                        {
 			    (yyval.tag).noexec = true;
 			}
-#line 2592 "gram.c"
+#line 2674 "gram.c"
     break;
 
   case 96: /* cmndtag: cmndtag EXEC  */
-#line 800 "gram.y"
+#line 870 "gram.y"
                                      {
 			    (yyval.tag).noexec = false;
 			}
-#line 2600 "gram.c"
+#line 2682 "gram.c"
     break;
 
   case 97: /* cmndtag: cmndtag SETENV  */
-#line 803 "gram.y"
+#line 873 "gram.y"
                                        {
 			    (yyval.tag).setenv = true;
 			}
-#line 2608 "gram.c"
+#line 2690 "gram.c"
     break;
 
   case 98: /* cmndtag: cmndtag NOSETENV  */
-#line 806 "gram.y"
+#line 876 "gram.y"
                                          {
 			    (yyval.tag).setenv = false;
 			}
-#line 2616 "gram.c"
+#line 2698 "gram.c"
     break;
 
   case 99: /* cmndtag: cmndtag LOG_INPUT  */
-#line 809 "gram.y"
+#line 879 "gram.y"
                                           {
 			    (yyval.tag).log_input = true;
 			}
-#line 2624 "gram.c"
+#line 2706 "gram.c"
     break;
 
   case 100: /* cmndtag: cmndtag NOLOG_INPUT  */
-#line 812 "gram.y"
+#line 882 "gram.y"
                                             {
 			    (yyval.tag).log_input = false;
 			}
-#line 2632 "gram.c"
+#line 2714 "gram.c"
     break;
 
   case 101: /* cmndtag: cmndtag LOG_OUTPUT  */
-#line 815 "gram.y"
+#line 885 "gram.y"
                                            {
 			    (yyval.tag).log_output = true;
 			}
-#line 2640 "gram.c"
+#line 2722 "gram.c"
     break;
 
   case 102: /* cmndtag: cmndtag NOLOG_OUTPUT  */
-#line 818 "gram.y"
+#line 888 "gram.y"
                                              {
 			    (yyval.tag).log_output = false;
 			}
-#line 2648 "gram.c"
+#line 2730 "gram.c"
     break;
 
   case 103: /* cmndtag: cmndtag FOLLOWLNK  */
-#line 821 "gram.y"
+#line 891 "gram.y"
                                           {
 			    (yyval.tag).follow = true;
 			}
-#line 2656 "gram.c"
+#line 2738 "gram.c"
     break;
 
   case 104: /* cmndtag: cmndtag NOFOLLOWLNK  */
-#line 824 "gram.y"
+#line 894 "gram.y"
                                             {
 			    (yyval.tag).follow = false;
 			}
-#line 2664 "gram.c"
+#line 2746 "gram.c"
     break;
 
   case 105: /* cmndtag: cmndtag MAIL  */
-#line 827 "gram.y"
+#line 897 "gram.y"
                                      {
 			    (yyval.tag).send_mail = true;
 			}
-#line 2672 "gram.c"
+#line 2754 "gram.c"
     break;
 
   case 106: /* cmndtag: cmndtag NOMAIL  */
-#line 830 "gram.y"
+#line 900 "gram.y"
                                        {
 			    (yyval.tag).send_mail = false;
 			}
-#line 2680 "gram.c"
+#line 2762 "gram.c"
     break;
 
   case 107: /* cmnd: ALL  */
-#line 835 "gram.y"
+#line 905 "gram.y"
                             {
 			    (yyval.member) = new_member(NULL, ALL);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2692 "gram.c"
+#line 2775 "gram.c"
     break;
 
   case 108: /* cmnd: ALIAS  */
-#line 842 "gram.y"
+#line 913 "gram.y"
                               {
 			    (yyval.member) = new_member((yyvsp[0].string), ALIAS);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2704 "gram.c"
+#line 2789 "gram.c"
     break;
 
   case 109: /* cmnd: COMMAND  */
-#line 849 "gram.y"
+#line 922 "gram.y"
                                 {
 			    struct sudo_command *c;
 
@@ -2724,264 +2809,294 @@ yyreduce:
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].command).cmnd);
+			    if ((yyvsp[0].command).args != NULL)
+				parser_leak_remove(LEAK_PTR, (yyvsp[0].command).args);
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2723 "gram.c"
+#line 2812 "gram.c"
     break;
 
   case 112: /* $@1: %empty  */
-#line 869 "gram.y"
+#line 946 "gram.y"
                               {
 			    alias_line = this_lineno;
 			    alias_column = sudolinebuf.toke_start + 1;
 			}
-#line 2732 "gram.c"
+#line 2821 "gram.c"
     break;
 
   case 113: /* hostalias: ALIAS $@1 '=' hostlist  */
-#line 872 "gram.y"
+#line 949 "gram.y"
                                        {
 			    if (!alias_add(&parsed_policy, (yyvsp[-3].string), HOSTALIAS,
 				sudoers, alias_line, alias_column, (yyvsp[0].member))) {
 				alias_error((yyvsp[-3].string), errno);
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[-3].string));
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			}
-#line 2744 "gram.c"
+#line 2835 "gram.c"
     break;
 
   case 116: /* hostlist: hostlist ',' ophost  */
-#line 883 "gram.y"
+#line 962 "gram.y"
                                             {
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			    HLTQ_CONCAT((yyvsp[-2].member), (yyvsp[0].member), entries);
 			    (yyval.member) = (yyvsp[-2].member);
 			}
-#line 2753 "gram.c"
+#line 2845 "gram.c"
     break;
 
   case 119: /* $@2: %empty  */
-#line 893 "gram.y"
+#line 973 "gram.y"
                               {
 			    alias_line = this_lineno;
 			    alias_column = sudolinebuf.toke_start + 1;
 			}
-#line 2762 "gram.c"
+#line 2854 "gram.c"
     break;
 
   case 120: /* cmndalias: ALIAS $@2 '=' cmndlist  */
-#line 896 "gram.y"
+#line 976 "gram.y"
                                        {
 			    if (!alias_add(&parsed_policy, (yyvsp[-3].string), CMNDALIAS,
 				sudoers, alias_line, alias_column, (yyvsp[0].member))) {
 				alias_error((yyvsp[-3].string), errno);
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[-3].string));
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			}
-#line 2774 "gram.c"
+#line 2868 "gram.c"
     break;
 
   case 123: /* cmndlist: cmndlist ',' digcmnd  */
-#line 907 "gram.y"
+#line 989 "gram.y"
                                              {
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			    HLTQ_CONCAT((yyvsp[-2].member), (yyvsp[0].member), entries);
 			    (yyval.member) = (yyvsp[-2].member);
 			}
-#line 2783 "gram.c"
+#line 2878 "gram.c"
     break;
 
   case 126: /* $@3: %empty  */
-#line 917 "gram.y"
+#line 1000 "gram.y"
                               {
 			    alias_line = this_lineno;
 			    alias_column = sudolinebuf.toke_start + 1;
 			}
-#line 2792 "gram.c"
+#line 2887 "gram.c"
     break;
 
   case 127: /* runasalias: ALIAS $@3 '=' userlist  */
-#line 920 "gram.y"
+#line 1003 "gram.y"
                                        {
 			    if (!alias_add(&parsed_policy, (yyvsp[-3].string), RUNASALIAS,
 				sudoers, alias_line, alias_column, (yyvsp[0].member))) {
 				alias_error((yyvsp[-3].string), errno);
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[-3].string));
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			}
-#line 2804 "gram.c"
+#line 2901 "gram.c"
     break;
 
   case 131: /* $@4: %empty  */
-#line 934 "gram.y"
+#line 1019 "gram.y"
                               {
 			    alias_line = this_lineno;
 			    alias_column = sudolinebuf.toke_start + 1;
 			}
-#line 2813 "gram.c"
+#line 2910 "gram.c"
     break;
 
   case 132: /* useralias: ALIAS $@4 '=' userlist  */
-#line 937 "gram.y"
+#line 1022 "gram.y"
                                        {
 			    if (!alias_add(&parsed_policy, (yyvsp[-3].string), USERALIAS,
 				sudoers, alias_line, alias_column, (yyvsp[0].member))) {
 				alias_error((yyvsp[-3].string), errno);
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[-3].string));
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			}
-#line 2825 "gram.c"
+#line 2924 "gram.c"
     break;
 
   case 135: /* userlist: userlist ',' opuser  */
-#line 948 "gram.y"
+#line 1035 "gram.y"
                                             {
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			    HLTQ_CONCAT((yyvsp[-2].member), (yyvsp[0].member), entries);
 			    (yyval.member) = (yyvsp[-2].member);
 			}
-#line 2834 "gram.c"
+#line 2934 "gram.c"
     break;
 
   case 136: /* opuser: user  */
-#line 954 "gram.y"
+#line 1042 "gram.y"
                              {
 			    (yyval.member) = (yyvsp[0].member);
 			    (yyval.member)->negated = false;
 			}
-#line 2843 "gram.c"
+#line 2943 "gram.c"
     break;
 
   case 137: /* opuser: '!' user  */
-#line 958 "gram.y"
+#line 1046 "gram.y"
                                  {
 			    (yyval.member) = (yyvsp[0].member);
 			    (yyval.member)->negated = true;
 			}
-#line 2852 "gram.c"
+#line 2952 "gram.c"
     break;
 
   case 138: /* user: ALIAS  */
-#line 964 "gram.y"
+#line 1052 "gram.y"
                               {
 			    (yyval.member) = new_member((yyvsp[0].string), ALIAS);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2864 "gram.c"
+#line 2966 "gram.c"
     break;
 
   case 139: /* user: ALL  */
-#line 971 "gram.y"
+#line 1061 "gram.y"
                             {
 			    (yyval.member) = new_member(NULL, ALL);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2876 "gram.c"
+#line 2979 "gram.c"
     break;
 
   case 140: /* user: NETGROUP  */
-#line 978 "gram.y"
+#line 1069 "gram.y"
                                  {
 			    (yyval.member) = new_member((yyvsp[0].string), NETGROUP);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2888 "gram.c"
+#line 2993 "gram.c"
     break;
 
   case 141: /* user: USERGROUP  */
-#line 985 "gram.y"
+#line 1078 "gram.y"
                                   {
 			    (yyval.member) = new_member((yyvsp[0].string), USERGROUP);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2900 "gram.c"
+#line 3007 "gram.c"
     break;
 
   case 142: /* user: WORD  */
-#line 992 "gram.y"
+#line 1087 "gram.y"
                              {
 			    (yyval.member) = new_member((yyvsp[0].string), WORD);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2912 "gram.c"
+#line 3021 "gram.c"
     break;
 
   case 144: /* grouplist: grouplist ',' opgroup  */
-#line 1002 "gram.y"
+#line 1099 "gram.y"
                                               {
+			    parser_leak_remove(LEAK_MEMBER, (yyvsp[0].member));
 			    HLTQ_CONCAT((yyvsp[-2].member), (yyvsp[0].member), entries);
 			    (yyval.member) = (yyvsp[-2].member);
 			}
-#line 2921 "gram.c"
+#line 3031 "gram.c"
     break;
 
   case 145: /* opgroup: group  */
-#line 1008 "gram.y"
+#line 1106 "gram.y"
                               {
 			    (yyval.member) = (yyvsp[0].member);
 			    (yyval.member)->negated = false;
 			}
-#line 2930 "gram.c"
+#line 3040 "gram.c"
     break;
 
   case 146: /* opgroup: '!' group  */
-#line 1012 "gram.y"
+#line 1110 "gram.y"
                                   {
 			    (yyval.member) = (yyvsp[0].member);
 			    (yyval.member)->negated = true;
 			}
-#line 2939 "gram.c"
+#line 3049 "gram.c"
     break;
 
   case 147: /* group: ALIAS  */
-#line 1018 "gram.y"
+#line 1116 "gram.y"
                               {
 			    (yyval.member) = new_member((yyvsp[0].string), ALIAS);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2951 "gram.c"
+#line 3063 "gram.c"
     break;
 
   case 148: /* group: ALL  */
-#line 1025 "gram.y"
+#line 1125 "gram.y"
                             {
 			    (yyval.member) = new_member(NULL, ALL);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2963 "gram.c"
+#line 3076 "gram.c"
     break;
 
   case 149: /* group: WORD  */
-#line 1032 "gram.y"
+#line 1133 "gram.y"
                              {
 			    (yyval.member) = new_member((yyvsp[0].string), WORD);
 			    if ((yyval.member) == NULL) {
 				sudoerserror(N_("unable to allocate memory"));
 				YYERROR;
 			    }
+			    parser_leak_remove(LEAK_PTR, (yyvsp[0].string));
+			    parser_leak_add(LEAK_MEMBER, (yyval.member));
 			}
-#line 2975 "gram.c"
+#line 3090 "gram.c"
     break;
 
 
-#line 2979 "gram.c"
+#line 3094 "gram.c"
 
       default: break;
     }
@@ -3175,7 +3290,7 @@ yyreturn:
   return yyresult;
 }
 
-#line 1040 "gram.y"
+#line 1143 "gram.y"
 
 /* Like yyerror() but takes a printf-style format string. */
 void
@@ -3327,6 +3442,7 @@ new_command(char *cmnd, char *args)
 	    "unable to allocate memory");
 	debug_return_ptr(NULL);
     }
+    /* garbage collected as part of struct member */
 
     c->cmnd = cmnd;
     c->args = args;
@@ -3383,15 +3499,18 @@ add_defaults(int type, struct member *bmem, struct defaults *defs)
 	    sudoerserror(N_("unable to allocate memory"));
 	    debug_return_bool(false);
 	}
-	if (bmem != NULL)
+	if (bmem != NULL) {
+	    parser_leak_remove(LEAK_MEMBER, bmem);
 	    HLTQ_TO_TAILQ(binding, bmem, entries);
-	else
+	} else {
 	    TAILQ_INIT(binding);
+	}
 
 	/*
 	 * Set type and binding (who it applies to) for new entries.
 	 * Then add to the global defaults list.
 	 */
+	parser_leak_remove(LEAK_DEFAULTS, defs);
 	HLTQ_FOREACH_SAFE(d, defs, entries, next) {
 	    d->type = type;
 	    d->binding = binding;
@@ -3420,7 +3539,9 @@ add_userspec(struct member *members, struct privilege *privs)
     u->line = this_lineno;
     u->column = sudolinebuf.toke_start + 1;
     u->file = rcstr_addref(sudoers);
+    parser_leak_remove(LEAK_MEMBER, members);
     HLTQ_TO_TAILQ(&u->users, members, entries);
+    parser_leak_remove(LEAK_PRIVILEGE, privs);
     HLTQ_TO_TAILQ(&u->privileges, privs, entries);
     STAILQ_INIT(&u->comments);
     TAILQ_INSERT_TAIL(&parsed_policy.userspecs, u, entries);
@@ -3506,12 +3627,9 @@ free_default(struct defaults *def, struct member_list **binding)
 }
 
 void
-free_privilege(struct privilege *priv)
+free_cmndspecs(struct cmndspec_list *csl)
 {
     struct member_list *runasuserlist = NULL, *runasgrouplist = NULL;
-    struct member_list *prev_binding = NULL;
-    struct cmndspec *cs;
-    struct defaults *def;
     char *runcwd = NULL, *runchroot = NULL;
 #ifdef HAVE_SELINUX
     char *role = NULL, *type = NULL;
@@ -3519,12 +3637,12 @@ free_privilege(struct privilege *priv)
 #ifdef HAVE_PRIV_SET
     char *privs = NULL, *limitprivs = NULL;
 #endif /* HAVE_PRIV_SET */
-    debug_decl(free_privilege, SUDOERS_DEBUG_PARSER);
+    struct cmndspec *cs;
+    debug_decl(free_cmndspecs, SUDOERS_DEBUG_PARSER);
+
+    while ((cs = TAILQ_FIRST(csl)) != NULL) {
+	TAILQ_REMOVE(csl, cs, entries);
 
-    free(priv->ldap_role);
-    free_members(&priv->hostlist);
-    while ((cs = TAILQ_FIRST(&priv->cmndlist)) != NULL) {
-	TAILQ_REMOVE(&priv->cmndlist, cs, entries);
 	/* Only free the first instance of runcwd/runchroot. */
 	if (cs->runcwd != runcwd) {
 	    runcwd = cs->runcwd;
@@ -3570,6 +3688,20 @@ free_privilege(struct privilege *priv)
 	free_member(cs->cmnd);
 	free(cs);
     }
+
+    debug_return;
+}
+
+void
+free_privilege(struct privilege *priv)
+{
+    struct member_list *prev_binding = NULL;
+    struct defaults *def;
+    debug_decl(free_privilege, SUDOERS_DEBUG_PARSER);
+
+    free(priv->ldap_role);
+    free_members(&priv->hostlist);
+    free_cmndspecs(&priv->cmndlist);
     while ((def = TAILQ_FIRST(&priv->defaults)) != NULL) {
 	TAILQ_REMOVE(&priv->defaults, def, entries);
 	free_default(def, &prev_binding);
@@ -3665,6 +3797,7 @@ init_parser(const char *path, bool quiet, bool strict)
     debug_decl(init_parser, SUDOERS_DEBUG_PARSER);
 
     free_parse_tree(&parsed_policy);
+    parser_leak_init();
     init_lexer();
 
     rcstr_delref(sudoers);
@@ -3707,3 +3840,215 @@ init_options(struct command_options *opts)
     opts->limitprivs = NULL;
 #endif
 }
+
+bool
+parser_leak_add(enum parser_leak_types type, void *v)
+{
+#ifdef NO_LEAKS
+    struct parser_leak_entry *entry;
+    debug_decl(parser_leak_add, SUDOERS_DEBUG_PARSER);
+
+    if (v == NULL)
+	debug_return_bool(false);
+
+    entry = calloc(1, sizeof(*entry));
+    if (entry == NULL) {
+	sudo_warnx(U_("%s: %s"), __func__, U_("unable to allocate memory"));
+	debug_return_bool(false);
+    }
+    switch (type) {
+    case LEAK_PRIVILEGE:
+	entry->u.p = v;
+	break;
+    case LEAK_CMNDSPEC:
+	entry->u.cs = v;
+	break;
+    case LEAK_DEFAULTS:
+	entry->u.d = v;
+	break;
+    case LEAK_MEMBER:
+	entry->u.m = v;
+	break;
+    case LEAK_DIGEST:
+	entry->u.dig = v;
+	break;
+    case LEAK_RUNAS:
+	entry->u.rc = v;
+	break;
+    case LEAK_PTR:
+	entry->u.ptr = v;
+	break;
+    default:
+	free(entry);
+	sudo_warnx("unexpected leak type %d", type);
+	debug_return_bool(false);
+    }
+    entry->type = type;
+    SLIST_INSERT_HEAD(&parser_leak_list, entry, entries);
+    debug_return_bool(true);
+#else
+    return true;
+#endif /* NO_LEAKS */
+}
+
+bool
+parser_leak_remove(enum parser_leak_types type, void *v)
+{
+#ifdef NO_LEAKS
+    struct parser_leak_entry *entry, *prev = NULL;
+    debug_decl(parser_leak_remove, SUDOERS_DEBUG_PARSER);
+
+    SLIST_FOREACH(entry, &parser_leak_list, entries) {
+	switch (entry->type) {
+	case LEAK_PRIVILEGE:
+	    if (entry->u.p == v)
+	    	goto found;
+	    break;
+	case LEAK_CMNDSPEC:
+	    if (entry->u.cs == v)
+	    	goto found;
+	    break;
+	case LEAK_DEFAULTS:
+	    if (entry->u.d == v)
+	    	goto found;
+	    break;
+	case LEAK_MEMBER:
+	    if (entry->u.m == v)
+	    	goto found;
+	    break;
+	case LEAK_DIGEST:
+	    if (entry->u.dig == v)
+	    	goto found;
+	    break;
+	case LEAK_RUNAS:
+	    if (entry->u.rc == v)
+	    	goto found;
+	    break;
+	case LEAK_PTR:
+	    if (entry->u.ptr == v)
+	    	goto found;
+	    break;
+	default:
+	    sudo_warnx("unexpected leak type %d in %p", entry->type, entry);
+	}
+	prev = entry;
+    }
+    /* If this happens, there is a bug in the leak tracking code. */
+    sudo_warnx("%s: unable to find %p, type %d", __func__, v, type);
+    return false;
+found:
+    if (prev == NULL)
+	SLIST_REMOVE_HEAD(&parser_leak_list, entries);
+    else
+	SLIST_REMOVE_AFTER(prev, entries);
+    free(entry);
+    return true;
+#endif /* NO_LEAKS */
+}
+
+void
+parser_leak_free(void)
+{
+#ifdef NO_LEAKS
+    struct parser_leak_entry *entry;
+    void *next;
+    debug_decl(parser_leak_run, SUDOERS_DEBUG_PARSER);
+
+    /* Free the leaks. */
+    while ((entry = SLIST_FIRST(&parser_leak_list))) {
+	SLIST_REMOVE_HEAD(&parser_leak_list, entries);
+	switch (entry->type) {
+	case LEAK_PRIVILEGE:
+	    {
+		struct privilege *priv;
+
+		HLTQ_FOREACH_SAFE(priv, entry->u.p, entries, next)
+		    free_privilege(priv);
+		free(entry);
+	    }
+	    break;
+	case LEAK_CMNDSPEC:
+	    {
+		struct cmndspec_list specs;
+
+		HLTQ_TO_TAILQ(&specs, entry->u.cs, entries);
+		free_cmndspecs(&specs);
+		free(entry);
+	    }
+	    break;
+	case LEAK_DEFAULTS:
+	    {
+		struct defaults_list defs;
+
+		HLTQ_TO_TAILQ(&defs, entry->u.d, entries);
+		free_defaults(&defs);
+		free(entry);
+	    }
+	    break;
+	case LEAK_MEMBER:
+	    {
+		struct member *m;
+
+		HLTQ_FOREACH_SAFE(m, entry->u.m, entries, next)
+		    free_member(m);
+		free(entry);
+	    }
+	    break;
+	case LEAK_DIGEST:
+	    {
+		struct command_digest *dig;
+
+		HLTQ_FOREACH_SAFE(dig, entry->u.dig, entries, next) {
+		    free(dig->digest_str);
+		    free(dig);
+		}
+		free(entry);
+	    }
+	    break;
+	case LEAK_RUNAS:
+	    {
+		struct member *m;
+
+		if (entry->u.rc->runasusers != NULL) {
+		    HLTQ_FOREACH_SAFE(m, entry->u.rc->runasusers, entries, next)
+			free_member(m);
+		}
+		if (entry->u.rc->runasgroups != NULL) {
+		    HLTQ_FOREACH_SAFE(m, entry->u.rc->runasgroups, entries, next)
+			free_member(m);
+		}
+		free(entry->u.rc);
+		free(entry);
+		break;
+	    }
+	case LEAK_PTR:
+	    free(entry->u.ptr);
+	    free(entry);
+	    break;
+	default:
+	    sudo_warnx("unexpected garbage type %d", entry->type);
+	}
+    }
+
+    debug_return;
+#endif /* NO_LEAKS */
+}
+
+void
+parser_leak_init(void)
+{
+#ifdef NO_LEAKS
+    static bool initialized;
+    debug_decl(parser_leak_init, SUDOERS_DEBUG_PARSER);
+
+    if (!initialized) {
+	atexit(parser_leak_free);
+	initialized = true;
+	debug_return;
+    }
+
+    /* Already initialized, free existing leaks. */
+    parser_leak_free();
+    debug_return;
+#endif /* NO_LEAKS */
+}
diff --git a/plugins/sudoers/gram.h b/plugins/sudoers/gram.h
index 97c6638..e862e11 100644
--- a/plugins/sudoers/gram.h
+++ b/plugins/sudoers/gram.h
@@ -1,8 +1,8 @@
-/* A Bison parser, made by GNU Bison 3.7.4.  */
+/* A Bison parser, made by GNU Bison 3.7.5.  */
 
 /* Bison interface for Yacc-like parsers in C
 
-   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
+   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
    Inc.
 
    This program is free software: you can redistribute it and/or modify
@@ -167,7 +167,7 @@ extern int sudoersdebug;
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
 union YYSTYPE
 {
-#line 83 "gram.y"
+#line 88 "gram.y"
 
     struct cmndspec *cmndspec;
     struct defaults *defaults;
